<template>
  <div class="box">
    <div class="columns">
      <div class="column is-half" v-if="url !== ''">
        <img :src="url" />
      </div>
      <div class="column is-half" v-else>
        <textarea
          v-model="answer"
          :rows="rows"
          class="textarea is-medium"
          readonly
        ></textarea>
      </div>
      <div class="column is-half">
        <textarea
          v-model="yourText"
          :rows="rows"
          class="textarea is-medium"
        ></textarea>
        <p class="help">※ スペースは全角を使用してください</p>
        <p class="help">※ 読み仮名（≪から≫まで）の部分は入力不要です</p>
      </div>
    </div>
    <button class="button is-primary is-fullwidth" @click="check">完成</button>
    <div v-if="isCompleted" class="block content mt-3">
      <p class="is-size-4 m-3" v-html="checked" />
    </div>
  </div>
</template>

<script setup>
import { SequenceMatcher } from "../../difflib/src/sequenceMatcher";
const props = defineProps({
  url: String,
  height: Number,
  answer: String,
});

const yourText = ref("");
const rows = Math.floor(props.height / 40) + 1;

const isCompleted = ref(false);
const checked = ref("");
const check = () => {
  const sm = new SequenceMatcher();
  sm.setSeqs(
    props.answer.replace(/《.*?》/g, ""),
    yourText.value.replace(/《.*?》/g, "")
  );
  checked.value = sm.applyOpcodes();
  isCompleted.value = true;
};
</script>